# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _ramberg_osgood
else:
    import _ramberg_osgood

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import ooflib.SWIG.engine.properties.elasticity.nonlinear.general_nonlinear_elasticity
import ooflib.SWIG.engine.property
import ooflib.SWIG.engine.properties.elasticity.cijkl
import ooflib.SWIG.engine.symmmatrix
import ooflib.SWIG.engine.outputval
import ooflib.SWIG.engine.fieldindex
import ooflib.SWIG.engine.planarity
import ooflib.SWIG.engine.IO.propertyoutput
import ooflib.SWIG.engine.mastercoord
class CRambergOsgood(ooflib.SWIG.engine.properties.elasticity.nonlinear.general_nonlinear_elasticity.GeneralNonlinearElasticity):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, reg, _self, name, cijkl, alpha, s0, n):
        _ramberg_osgood.CRambergOsgood_swiginit(self, _ramberg_osgood.new_CRambergOsgood(reg, _self, name, cijkl, alpha, s0, n))
    __swig_destroy__ = _ramberg_osgood.delete_CRambergOsgood

# Register CRambergOsgood in _ramberg_osgood:
_ramberg_osgood.CRambergOsgood_swigregister(CRambergOsgood)
# -*- python -*-

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@nist.gov.

from ooflib.common.IO import parameter
from ooflib.engine import problem
from ooflib.engine import propertyregistration
from ooflib.engine.IO import isocijkl
from ooflib.common.IO import parameter

# The Python RambergOsgood class is an almost trival wrapper for the
# C++ CRambergOsgood class.  The wrapper just converts the modulus
# argument from a Python IsotropicRank4TensorCij object to a C++ Cijkl
# object.  That could be done with a typemap instead.  It's done this
# way only because other Elasticity classes do it this way.  They do
# it because AnsioElasticity classes need to be wrapped because they
# are derived from PythonNative, because they are subclassed in
# Python.

class RambergOsgood(CRambergOsgood):
    def __init__(self, registration, name, cijkl, alpha, s0, n):
        CRambergOsgood.__init__(self, registration, self, name,
                                cijkl.tensorForm(),
                                alpha, s0, n)

reg = propertyregistration.PropertyRegistration(
    name='Mechanical:Elasticity:RambergOsgood',
    subclass=RambergOsgood,
    ordering=202,
    params=[
        isocijkl.IsotropicCijklParameter(
            'cijkl',
            isocijkl.IsotropicRank4TensorCij(c11=1.0,c12=0.5),
            tip=parameter.emptyTipString),
# TODO: alpha needs a tip string
        parameter.FloatParameter('alpha',0.0,tip=parameter.emptyTipString),
        parameter.FloatParameter('s0',1.0,tip="Yield stress"),
        parameter.FloatParameter('n',1.0,tip="Exponent")],
    propertyType="Elasticity",
    tip="Nonlinear elasticity of the Ramberg-Osgood type."
)

reg.fluxInfo(
    fluxes=[problem.Stress],
    fields=[problem.Displacement],
    time_derivs=[0],
    nonlinear=True,
    time_dependent=False )


