# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _heatconductivity
else:
    import _heatconductivity

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import ooflib.SWIG.engine.property
import ooflib.SWIG.engine.symmmatrix
import ooflib.SWIG.engine.outputval
import ooflib.SWIG.engine.fieldindex
import ooflib.SWIG.engine.planarity
import ooflib.SWIG.engine.IO.propertyoutput
import ooflib.SWIG.engine.mastercoord
class IsoHeatConductivity(ooflib.SWIG.engine.property.Property):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, reg, name, kappa):
        _heatconductivity.IsoHeatConductivity_swiginit(self, _heatconductivity.new_IsoHeatConductivity(reg, name, kappa))
    __swig_destroy__ = _heatconductivity.delete_IsoHeatConductivity

# Register IsoHeatConductivity in _heatconductivity:
_heatconductivity.IsoHeatConductivity_swigregister(IsoHeatConductivity)
class AnisoHeatConductivity(ooflib.SWIG.engine.property.Property):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, reg, name, k):
        _heatconductivity.AnisoHeatConductivity_swiginit(self, _heatconductivity.new_AnisoHeatConductivity(reg, name, k))
    __swig_destroy__ = _heatconductivity.delete_AnisoHeatConductivity

# Register AnisoHeatConductivity in _heatconductivity:
_heatconductivity.AnisoHeatConductivity_swigregister(AnisoHeatConductivity)
# -*- python -*-

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@nist.gov.

from ooflib.common.IO import parameter
from ooflib.common.IO import xmlmenudump
from ooflib.engine import problem
from ooflib.engine import propertyregistration
from ooflib.SWIG.engine import symmmatrix

PropertyRegistration = propertyregistration.PropertyRegistration

## ISOTROPIC

reg = PropertyRegistration(
    'Thermal:Conductivity:Isotropic',
    IsoHeatConductivity,
    ordering=97,
    params=[parameter.FloatParameter('kappa',
                                     1.0, tip=parameter.emptyTipString)],
    outputs=["Material Constants:Thermal:Conductivity K"],
    propertyType="ThermalConductivity",
    tip="Isotropic thermal conductivity.",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/isoheatcond.xml')
    )

reg.fluxInfo(fluxes=[problem.Heat_Flux], fields=[problem.Temperature],
             time_derivs=[0])

## TRICLINIC

reg = PropertyRegistration(
    'Thermal:Conductivity:Anisotropic:Triclinic',
    AnisoHeatConductivity,
    105,
    params=[symmmatrix.TriclinicRank2TensorParameter(
        'kappa',
        symmmatrix.TriclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
        tip=parameter.emptyTipString)],
    outputs=["Material Constants:Thermal:Conductivity K"],
    propertyType="ThermalConductivity",
    tip="Triclinic thermal conductivity",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisoheatcond.xml'))

reg.fluxInfo(fluxes=[problem.Heat_Flux], fields=[problem.Temperature],
             time_derivs=[0])

## MONOCLINIC

reg = PropertyRegistration(
    'Thermal:Conductivity:Anisotropic:Monoclinic',
    AnisoHeatConductivity,
    104,
    params=[symmmatrix.MonoclinicRank2TensorParameter(
        'kappa',
        symmmatrix.MonoclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
        tip=parameter.emptyTipString)],
    outputs=["Material Constants:Thermal:Conductivity K"],
    propertyType="ThermalConductivity",
    tip="Monoclinic thermal conductivity.",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisoheatcond.xml'))

reg.fluxInfo(fluxes=[problem.Heat_Flux], fields=[problem.Temperature],
             time_derivs=[0])

## ORTHORHOMBIC

reg = PropertyRegistration(
    'Thermal:Conductivity:Anisotropic:Orthorhombic',
    AnisoHeatConductivity,
    103,
    params=[symmmatrix.OrthorhombicRank2TensorParameter(
        'kappa',
        symmmatrix.OrthorhombicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
        tip=parameter.emptyTipString)],
    outputs=["Material Constants:Thermal:Conductivity K"],
    propertyType="ThermalConductivity",
    tip="Orthorhombic thermal conductivity.",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisoheatcond.xml'))

reg.fluxInfo(fluxes=[problem.Heat_Flux], fields=[problem.Temperature],
             time_derivs=[0])

## TETRAGONAL

reg = PropertyRegistration(
    'Thermal:Conductivity:Anisotropic:Tetragonal',
    AnisoHeatConductivity,
    101,
    params=[symmmatrix.TetragonalRank2TensorParameter(
        'kappa',
        symmmatrix.TetragonalRank2Tensor(xx=1.0, zz=0.5),
        tip=parameter.emptyTipString)],
    outputs=["Material Constants:Thermal:Conductivity K"],
    propertyType="ThermalConductivity",
    tip="Tetragonal thermal conductivity.",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisoheatcond.xml'))

reg.fluxInfo(fluxes=[problem.Heat_Flux], fields=[problem.Temperature],
             time_derivs=[0])

## TRIGONAL

reg = PropertyRegistration(
    'Thermal:Conductivity:Anisotropic:Trigonal',
    AnisoHeatConductivity,
    102,
    params=[symmmatrix.TrigonalRank2TensorParameter(
        'kappa',
        symmmatrix.TrigonalRank2Tensor(xx=1.0, zz=0.5),
        tip=parameter.emptyTipString)],
    outputs=["Material Constants:Thermal:Conductivity K"],
    propertyType="ThermalConductivity",
    tip="Trigonal thermal conductivity.",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisoheatcond.xml'))

reg.fluxInfo(fluxes=[problem.Heat_Flux], fields=[problem.Temperature],
time_derivs=[0])

## HEXAGONAL

reg = PropertyRegistration(
    'Thermal:Conductivity:Anisotropic:Hexagonal',
    AnisoHeatConductivity,
    100,
    params=[symmmatrix.HexagonalRank2TensorParameter(
        'kappa',
        symmmatrix.HexagonalRank2Tensor(xx=1.0, zz=0.5),
        tip=parameter.emptyTipString)],
    outputs=["Material Constants:Thermal:Conductivity K"],
    propertyType="ThermalConductivity",
    tip="Hexagonal thermal conductivity.",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisoheatcond.xml'))

reg.fluxInfo(fluxes=[problem.Heat_Flux], fields=[problem.Temperature],
time_derivs=[0])

## CUBIC

reg = PropertyRegistration(
    'Thermal:Conductivity:Anisotropic:Cubic',
    AnisoHeatConductivity,
    99,
    params=[symmmatrix.CubicRank2TensorParameter(
            'kappa',
            symmmatrix.CubicRank2Tensor(xx=1.0),
            tip=parameter.emptyTipString)],
    outputs=["Material Constants:Thermal:Conductivity K"],
    propertyType="ThermalConductivity",
    tip="Cubic thermal conductivity.",
    discussion=xmlmenudump.loadFile(
        'DISCUSSIONS/engine/property/anisoheatcond.xml'))

reg.fluxInfo(fluxes=[problem.Heat_Flux], fields=[problem.Temperature],
             time_derivs=[0])


